(define maxx 640)
(define maxy 480)

(if (< (length (argv)) 2)
    (begin (display "Usage: test-sdl path-to-ttf-font")
	   (newline)
	   (exit 1)))
(define fontname (cadr (argv)))

(ttf-init)

(sdl-wm-setcaption "TestSDL" "TestSDL")
(define s (sdl-setvideomode maxx maxy 0 (+ sdl_hwsurface
					   sdl_hwpalette
					   sdl_doublebuf)))

(sdl-showcursor #f)

(do ((i 0 (+ i 1)))
    ((= i 1000))
  (sdl-fillrect s
		(make-sdl-rect (random maxx)
			       (random maxy)
			       (random maxx)
			       (random maxy))
		(sdl-maprgb (sdl-surface-pixelformat s)
			    (random 255)
			    (random 255)
			    (random 255))))

(sdl-fillrect s (make-sdl-rect 10 10 300 250) (sdl-maprgb (sdl-surface-pixelformat s) 0 0 255))

(define f (ttf-openfont fontname 48))
(define s2 (ttf-rendertext-solid f "Hello, world!" (fill-sdl-color! (make-sdl-color)
								    255 255 255)))
(sdl-blitsurface s2 *sdl-rect-nil* s (make-sdl-rect 10 100 50 50))
(sdl-freesurface s2)
(define s2 (ttf-rendertext-blended f "Hello, world!" (fill-sdl-color! (make-sdl-color)
								      255 255 255)))
(sdl-blitsurface s2 *sdl-rect-nil* s (make-sdl-rect 10 10 50 50))
(sdl-freesurface s2)

(let* ((x (img-load "unknown2-scale8.jpg"))
       (x2 (rotozoom-surface x 55 0.5 #t)))
  (sdl-blitsurface x *sdl-rect-nil* s (make-sdl-rect 300 200 300 300))
  (sdl-blitsurface x2 *sdl-rect-nil* s (make-sdl-rect 380 20 300 300))
  (sdl-freesurface x)
  (sdl-freesurface x2))

(sdl-flip s)

(let ((event (make-sdl-event)))
  (let loop ()
    (sdl-waitevent event)
    (let ((t (sdl-event-type event)))
      (if (= t sdl_quit)
	  'done
	  (begin (cond
		  ((= t sdl_keydown) (let* ((i (sdl-event-sym event))
					    (c (integer->char i)))
				       (if (or (= i 27) (memv c '(#\q #\Q)))
					   (begin (sdl-event-type-set! event sdl_quit)
						  (sdl-pushevent event))
					   (begin (display (list 'got-key c)) (newline)))))
		  (else (display (list 'event t)) (newline)))
		 (loop))))))

(ttf-quit)
